
dailyCmd:
  type: command
  debug: false
  name: daily
  usage: /daily
  description: 'Great description.'
  script:
    - inventory open d:guiDaily
emptySlot:
  type: item
  material: clay_ball
  display name: ''
  mechanisms:
    custom_model_data: '1'
procDaily:
  type: procedure
  debug: false
  script:
    - define days <player.flag[dailyReward].get[<server.flag[weekCounter]||1>]||<list[]>>
    - define dateCheck <[days].contains[<util.time_now.format[yyyy/MM/dd]>].not>
    - define padding 7
    - definemap panels:
        1:
        - <&translate[space.<[padding]>].font[custom:space]><&translate[gui.daily_day_ready]>
        - <&translate[space.<[padding]>].font[custom:space]><&translate[gui.daily_day_claimed]>
        - <&translate[space.<element[29].add[<[padding]>]>].font[custom:space]>
        2:
        - <&translate[space.<[padding]>].font[custom:space]><&translate[gui.daily_day_ready_2]>
        - <&translate[space.<[padding]>].font[custom:space]><&translate[gui.daily_day_claimed_2]>
        - <&translate[space.<element[29].add[<[padding]>]>].font[custom:space]>
        3:
        - <&translate[space.<[padding].add[5]>].font[custom:space]><&translate[gui.daily_day7_ready]>
        - <&translate[space.<[padding].add[5]>].font[custom:space]><&translate[gui.daily_day7_claimed]>
        - <&translate[space.<element[29].add[<[padding]>]>].font[custom:space]>

    - define gui <&translate[space.-12].font[custom:space]><&translate[gui.daily_menu]>
    - repeat 7:
        - if <[value]> == 1:
            - define gui <[gui]><&translate[space.-187].font[custom:space]>
        - if <[value]> == 4:
            - define gui <[gui]><&translate[space.-<element[29].add[<[padding]>].mul[3]>].font[custom:space]>
        - if <[value]> < 4:
            - define type 1
        - if <[value]> < 7 && <[value]> > 3:
            - define type 2
        - if <[value]> == 7:
            - define type 3
        - if <[value]> <= <[days].size.add[1]>:
            - if <[value]> < <[days].size.add[1]>:
                - define gui <[gui]><[panels].get[<[type]>].get[2]>
            - else:
                - if <[dateCheck]>:
                    - define gui <[gui]><[panels].get[<[type]>].get[1]>
                - else:
                    - define gui <[gui]><[panels].get[<[type]>].get[3]>
        - else:
                - define gui <[gui]><[panels].get[<[type]>].get[3]>
    - determine <[gui].font[custom:daily]>
guiDaily:
  type: inventory
  inventory: CHEST
  gui: true
  debug: false
  title: '<&f><proc[procDaily]>'
  procedural items:
   - define list <list[]>
   - define days <player.flag[dailyReward].get[<server.flag[weekCounter]||1>]||<list[]>>
   - define dateCheck <[days].contains[<util.time_now.format[yyyy/MM/dd]>].not>
   - define reward <yaml[dailyreward].read[reward]>
   - repeat 6:
        - if <[value]> == 4:
           - if <element[6]> < <[days].size>:
                - define list <[list].include[<item[air].repeat_as_list[6]>]>
           - else:
                - define list <[list].include[<item[emptySlot].with[display=<[reward].get[7].display>].repeat_as_list[6]>]>
        - if <[value]> <= <[days].size.add[1]>:
            - if <[value]> < <[days].size.add[1]>:
                - define list <[list].include[<item[air]>]>
            - else:
                - define list <[list].include[<[reward].get[<[value]>]>]>

        - else:
            - define list <[list].include[<[reward].get[<[value]>]>]>
   - determine <[list]>
  slots:
    - [] [air] [] [air] [] [air] [air] [air] [air]
    - [air] [air] [air] [air] [air] [air] [] [] []
    - [air] [air] [air] [air] [air] [air] [] [] []
    - [] [air] [] [air] [] [air] [air] [air] [air]
    - [air] [air] [air] [air] [air] [air] [air] [air] [air]
guiDailyHandler:
  type: world
  debug: false
  events:
    on tick:
        - if <yaml.list.contains[dailyreward].not>:
            - yaml id:dailyreward load:yaml/dailyreward.yml
    on player joins:
        - define days <player.flag[dailyReward].get[<server.flag[weekCounter]||1>]||<list[]>>
        - define dateCheck <[days].contains[<util.time_now.format[yyyy/MM/dd]>].not>
        - if <[dateCheck]>:
            - inventory open d:guiDaily
    on player clicks item in guiDaily:
        - determine passively cancelled
        - ratelimit <player> 5t
        - define ing <context.clicked_inventory.id_type||null>
        - if <[ing]> == null:
          - stop
        - if <[ing]> != script:
          - stop
        - if <context.item.material.name> != air:
            - define days <player.flag[dailyReward].get[<server.flag[weekCounter]||1>]||<list[]>>
            - define dateCheck <[days].contains[<util.time_now.format[yyyy/MM/dd]>].not>
            - definemap slot:
                1: 1
                3: 2
                5: 3
                28: 4
                30: 5
                32: 6
                16: 7
                17: 7
                18: 7
                25: 7
                26: 7
                27: 7
            - if <[days].size.add[1]> == <[slot].get[<context.slot>]>:
                - if <[dateCheck]>:
                    - if <[slot].get[<context.slot>]> == 7:
                        - define reward <yaml[dailyreward].read[reward]>
                        - give <[reward].get[7]>
                    - else:
                        - give <item[<context.item.simple>].with[quantity=<context.item.quantity>]>
                    - playsound <player> sound:entity_player_levelup
                    - define weekCounter <server.flag[weekCounter]||1>
                    - flag <player> dailyReward.<[weekCounter]>:->:<util.time_now.format[yyyy/MM/dd]> expire:7d
                    - inventory open d:guiDaily
                - else:
                    - playsound <player> sound:ENTITY_VILLAGER_NO
            - else:
                - playsound <player> sound:ENTITY_VILLAGER_NO